unit DBFNTX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OCI, o8Env, o8Session, db, o8Filter, DBCommon, DBFIndex, o8Util, ActiveX,
  contnrs, MemMgr;

const

  NTX_MAX_KEY       =      256;   // Maximum of length of key
  NTX_PAGE          =      1024;  // Dimantion of NTX page

  CL501RUSORDER: array [0..255] of Byte = (
0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17,
18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 180, 181,
182, 183, 184, 185, 186, 187, 188, 189, 49, 50, 51, 52, 53, 54,
55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 190, 191, 192, 193,
194, 195, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 196, 197,
 198, 199, 200, 108, 109, 110, 111, 112, 113, 115, 116, 117, 118,
 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131,
 132, 133, 134, 135, 136, 137, 138, 139, 140, 143, 144, 145, 146,
 147, 148, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 201,
 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214,
 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227,
 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240,
 241, 242, 243, 244, 245, 246, 247, 248, 160, 161, 162, 163, 164,
 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 114, 149,
 176, 177, 141, 178, 142, 179, 249, 250, 251, 252, 253, 254, 48, 255);

type

  //NTX Structute
  TCLIPPER_VERSION = (v500, v501, v520, v530);

  NTX_HEADER = packed record
    sign: WORD;                                 //2        0
    version: WORD;                              //2        2
    root: DWORD;                                //4        4
    next_page: DWORD;                           //4        8
    item_size: WORD;                            //2       12
    key_size: WORD;                             //2       14
    key_dec: WORD;                              //2       16
    max_item: WORD;                             //2       18
    half_page: WORD;                            //2       20
    key_expr: array [0..NTX_MAX_KEY-1] of Char; //256     22
    unique: Char;                               //1      278
    reserv1: Char;                              //1      279
    desc: Char;                                 //1      280
    reserv3: Char;                              //1      281
    for_expr: array [0..NTX_MAX_KEY-1] of Char; //256    282
    order: array [0..7] of char;                //8      538
    Rest: array [0..477] of char;               //478    546
  end;
                                                //1024

  //
  // Describer one ITEM
  //
  NTX_ITEM = packed record
    page: DWORD;
    rec_no: DWORD;
    key: array[0..NTX_PAGE-1] of Char;
  end;
  pNTX_ITEM = ^NTX_ITEM;

  //
  // Beginign of Index page
  //
  NTX_BUFFER = packed record
    count: WORD;
    ref: array[0..510] of WORD;
  end;
  pNTX_BUFFER = ^NTX_BUFFER;

  //Forword declarations
  TNTXIndex = class;

  {TNTXBuffers}
  TNTXBuffer = class
  private
    Fpage_offset: DWORD;
    Fchanged: boolean;
    Fpage: NTX_BUFFER;
  public
    constructor Create;
  end;

  {TNTXBuffers}
  TNTXBuffers = class(TObjectList)
  private
    function FindIndex(page_offset: DWORD; out Ind: Integer): boolean;
  public
    function GetPage(Handle: Integer; page_offset: DWORD; out page: pNTX_BUFFER; fRead: boolean = true): Integer;
    function GetNTXBuffer(Handle: Integer; page_offset: DWORD; out page: pNTX_BUFFER; fRead: boolean = true): Pointer;
    procedure SetPage(Handle: Integer; page_offset: DWORD; page: pNTX_BUFFER);
    procedure SetChanged(i: Integer);
    procedure Flush(Handle: Integer);
  end;

  {TNTXRange}
  TNTXRange = class(TPersistent)
  private

    FActive: boolean;
    FLoKey: String;
    FHiKey: String;
    FNTX: TNTXIndex;
    function GetActive: boolean;
    procedure SetActive(const Value: boolean);

  protected
  public

    function InRange(S: String): boolean;

    procedure ReOpen;

    property NTX: TNTXIndex read FNTX write FNTX;

  published

    property Active: boolean read GetActive write SetActive;
    property HiKey: String read FHiKey write FHiKey;
    property LoKey: String read FLoKey write FLoKey;

  end;

  {TNTXIndex}
  TNTXIndex = class(TIndex)
  private

    FLastOffset: DWORD;
    FReindex: boolean;
    FCreateIndexProc: boolean;
    FNTXBuffers: TNTXBuffers;
    FNTXFileName: String;
    NTXHandler: Integer;
    FHead: NTX_HEADER;
    FKeyExpresion: String;
    FForExpresion: String;
    FKeyParser: To8ExprParser;
    FForParser: To8ExprParser;
    FForExists: boolean;
    FKeyTranslate: boolean;
    FCl501Rus: boolean;
    FFileLock: boolean;
    FSeekRecord: Integer;
    FSeekKey: String;
    FSeekOk: boolean;
    FTemp: boolean;
    FNTXRange: TNTXRange;
    FOnSubNtx: TOnSubNtx;
    FDestructor: boolean;
    FClipperVer: TCLIPPER_VERSION;

    procedure SetNTXFileName(const Value: String);
    procedure SetKeyExpresion(Value: String);
    procedure SetForExpresion(Value: String);
    function CompareKeys(S1, S2: PChar; MaxLen: Cardinal): Integer;
    function GetFreePage: DWORD;
    procedure SetUnique(const Value: boolean);
    function GetUnique: boolean;
    procedure SetDesc(const Value: boolean);
    function GetDesc: boolean;
    function SeekFirstInternal(Key: String; SoftSeek: boolean = false): boolean;
    function SeekLastInternal(Key: String; SoftSeek: boolean = false): boolean;
    function GetOrder: String;
    procedure SetOrder(Value: String);
    procedure ChekExpression(var Value: String);
    function GetOwnerTable: TDataSet;
    procedure ClearIfChange;

  protected

    FCurrentKey: String;
    FCurrentRec: DWORD;
    function GetIsRanged: boolean; override;
    procedure AssignIndex(oInd: TNTXIndex);
    function InternalFirst: TGetResult; override;
    function InternalNext: TGetResult; override;
    function InternalPrior: TGetResult; override;
    function InternalLast: TGetResult; override;
    function GetCurrentKey: String; override;
    function GetCurrentRec: DWORD; override;
    function FileRead(Handle: Integer; var Buffer; Count: LongWord): Integer;
    function FileWrite(Handle: Integer; const Buffer; Count: LongWord): Integer;
    function AddItem(ntxItem: pNTX_ITEM): boolean;

  public

    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function IsEqual(Value: TIndex): Boolean; override;
    function CmpKeys(ItemKey, CurrKey: pChar; KSize: Integer = 0): Integer;
    function CmpKeys1(ItemKey, CurrKey: pChar; KSize: Integer = 0): Integer;
    function CmpKeys2(ItemKey, CurrKey: pChar; KSize: Integer = 0): Integer;
    procedure TransKey(Key: pChar; KSize: Integer = 0);
    function Open: boolean; override;
    procedure Close; override;
    function IsOpen: boolean; override;
    function SetToRecord: boolean; overload; override;
    function SetToRecord(Rec: Longint): boolean; overload; override;
    function SetToRecord(Key: String; Rec: Longint): boolean; overload; override;
    function Seek(Key: String; SoftSeek: boolean = false): boolean; override;
    function SeekFirst(Key: String; SoftSeek: boolean = false): boolean; override;
    function SeekFields(const KeyFields: string; const KeyValues: Variant): Integer; override;
    function SubIndex(LoKey, HiKey: String): boolean; override;
    function SubNtx(var SubNtxFile: String; LoKey, HiKey: String): boolean;
    function FillFirstBufRecords(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): longint; override;
    function FillLastBufRecords(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): longint; override;
    function EvaluteKeyExpr: String; override;
    function SuiteFieldList(fl: String; out m: Integer): Integer; override;
    function EvaluteForExpr: boolean; override;
    function GetRecordByIndex(GetMode: TGetMode; var cRec: Longint): TGetResult; override;
    function GetFirstByIndex(var cRec: Longint): TGetResult; override;
    function GetLastByIndex(var cRec: Longint): TGetResult; override;
    procedure First; override;
    procedure Next; override;
    procedure Prior; override;
    procedure Last; override;
    function LastKey(out LastKey: String; out LastRec: LongInt): boolean; override;
    function NextBuffer(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): Longint; override;
    function PriorBuffer(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): Longint; override;
    procedure SetRangeFields(FieldList: String; FieldValues: array of const); overload; override;
    procedure SetRangeFields(FieldList: String; FieldValues: variant); overload; override;
    function InRange(Key: String): boolean; override;

    function FLock: boolean; override;
    function FUnLock: boolean; override;

    procedure StartUpdate(UnLock: boolean = true); override;
    procedure Flush; override;

    procedure DeleteKey(sKey: String; nRec: Longint); override;
    procedure AddKey(sKey: String; nRec: Longint); override;

    procedure CreateIndex; override;
    procedure Reindex; override;


    property OwnerTable: TDataSet read GetOwnerTable;

  published

    property NTXFileName: String read FNTXFileName write SetNTXFileName;
    property KeyExpresion: String read FKeyExpresion write SetKeyExpresion stored false;
    property ForExpresion: String read FForExpresion write SetForExpresion stored false;
    property KeyTranslate: boolean read FKeyTranslate write FKeyTranslate default true;
    property Clipper501RusOrder: boolean read FCl501Rus write FCl501Rus;
    property Unique: boolean read GetUnique write SetUnique;
    property Desc: boolean read GetDesc write SetDesc;
    property Order: String read GetOrder write SetOrder;
    property Temp: boolean read FTemp write FTemp;
    property NTXRange: TNTXRange read FNTXRange write FNTXRange;
    property ClipperVer: TCLIPPER_VERSION read FClipperVer write FClipperVer default v500;

    property OnSubIndex;
    property OnEvaluteKey;
    property OnEvaluteFor;
    property OnCompareKeys;
    property OnSubNtx: TOnSubNtx read FOnSubNtx write FOnSubNtx;

  end;

implementation

uses
   DBFDataSet;

{ TNTXIndex }

procedure TNTXIndex.Assign(Source: TPersistent);
begin
  if Source is TNTXIndex then
    AssignIndex(TNTXIndex(Source))
  else
    inherited Assign(Source);
end;

procedure TNTXIndex.AssignIndex(oInd: TNTXIndex);
begin
  if oInd <> nil then
  begin
    Name := oInd.Name;
    NTXFileName := oInd.NTXFileName;
  end;
end;

procedure TNTXIndex.Close;
begin
  Flush;
  FNTXBuffers.Clear;
  FileClose(NTXHandler);
  NTXHandler := -1;
  FForExists := false;
  if FTemp then begin
    DeleteFile(FNTXFileName);
    if not FDestructor then
      Collection.Delete(Index);
  end;
end;

constructor TNTXIndex.Create(Collection: TCollection);
var
  FieldMap: TFieldMap;
  i: Integer;
begin
  inherited Create(Collection);

  FClipperVer := v500;

  FHead.sign := 6;
  FHead.version := 1;
  FHead.root := 0;
  FHead.next_page := 0;
  FHead.item_size := 0;
  FHead.key_size := 0;
  FHead.key_dec := 0;
  FHead.max_item := 0;
  FHead.half_page := 0;
  for i := 0 to NTX_MAX_KEY-1 do FHead.key_expr[i] := #0;
  FHead.unique := #0;
  FHead.reserv1 := #0;
  FHead.desc := #0;
  FHead.reserv3 := #0;
  for i := 0 to NTX_MAX_KEY-1 do FHead.for_expr[i] := #0;
  for i := 0 to 7 do FHead.order[i] := #0;
  for i := 0 to 477 do FHead.Rest[i] := #0;

  FKeyParser := To8ExprParser.Create(TDBFNTX(FIndexes.Owner), '', [], [poExtSyntax], '', nil, FieldMap);
  FKeyParser.IndexKeyValue := true;
  FForParser := To8ExprParser.Create(TDBFNTX(FIndexes.Owner), '', [], [poExtSyntax], '', nil, FieldMap);
  FForParser.IndexKeyValue := true;
  FKeyTranslate := true;
  FCl501Rus := false;
  FFileLock := false;
  FTemp := false;
  FForExists := false;

  FNTXRange := TNTXRange.Create;
  FNTXRange.NTX := self;

  FNTXBuffers := TNTXBuffers.Create;
  FCreateIndexProc:= false;
  FReindex := false;

  FOnSubNtx := nil;

  FDestructor := false;

end;

destructor TNTXIndex.Destroy;
begin
  FDestructor := true;
  if IsOpen then Close;
  FKeyParser.Free;
  FForParser.Free;
  FNTXRange.Free;
  FNTXBuffers.Free;
  inherited Destroy;
end;

function TNTXIndex.EvaluteForExpr: boolean;
begin
  if Assigned(FOnEvaluteFor) then
    FOnEvaluteFor(self, Result)
  else
    Result := FForParser.Execute;
end;

function TNTXIndex.EvaluteKeyExpr: String;
begin
  if Assigned(FOnEvaluteKey) then
    FOnEvaluteKey(self, Result)
  else
    Result := FKeyParser.EvaluteKey;
end;

function TNTXIndex.InternalFirst: TGetResult;
var
  level: Integer;
  v: WORD;

  function Pass(page_off: DWORD): TGetResult;
  var
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
  begin
    Inc(level);
    try

      FNTXBuffers.GetPage(NTXHandler, page_off, page);

      item := pNTX_ITEM(pChar(page) + page.ref[0]);
      if ( item.page <> 0 ) then begin
        Result := Pass(item.page);
        if Result = grOK then Exit;
      end;
      if page.count <> 0 then begin
        //
        if FKeyTranslate then begin
          Move(item.key, Srckey, FHead.key_size);
          Srckey[FHead.key_size] := #0;
          TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
          SetString(FCurrentKey, Destkey, FHead.key_size);
        end else
          SetString(FCurrentKey, item.key, FHead.key_size);
        FCurrentRec := item.rec_no;
        //
        Result := grOK;
      end else
        if level = 1 then
          Result := grEOF
        else
          Result := grError;
      Exit;
    finally
      Dec(level);
    end;
  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  level := 0;
  Result := Pass(FHead.root);

end;

procedure TNTXIndex.First;
begin
  if InternalFirst = grOk then
    TDBFNTX(FIndexes.Owner).RecNo := FCurrentRec;
end;

function TNTXIndex.IsEqual(Value: TIndex): Boolean;
var
  oNTX: TNTXIndex;
begin
  oNTX := Value as TNTXIndex;
  Result := ( (FName = oNTX.Name) and (FNTXFileName = oNTX.NTXFileName) );
end;

function TNTXIndex.IsOpen: boolean;
begin
  Result := (NTXHandler > 0);
end;

function TNTXIndex.InternalLast: TGetResult;
var
  level: Integer;
  v: WORD;

  function Pass(page_off: DWORD): TGetResult;
  var
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
  begin
    Inc(level);
    try

      FNTXBuffers.GetPage(NTXHandler, page_off, page);

      item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
      if ( item.page <> 0 ) then begin
        Result := Pass(item.page);
        if Result = grOK then Exit;
      end;
      if page.count <> 0 then begin
        //
        item := pNTX_ITEM(pChar(page) + page.ref[page.count - 1]);
        if FKeyTranslate then begin
          Move(item.key, Srckey, FHead.key_size);
          Srckey[FHead.key_size] := #0;
          TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
          SetString(FCurrentKey, Destkey, FHead.key_size);
        end else
          SetString(FCurrentKey, item.key, FHead.key_size);
        FCurrentRec := item.rec_no;
        //
        Result := grOK;
      end else
        if level = 1 then
          Result := grBOF
        else
          Result := grError;
      Exit;
    finally
      Dec(level);
    end;
  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  level := 0;
  Result := Pass(FHead.root);

end;

function TNTXIndex.InternalPrior: TGetResult;
var
  Found: boolean;
  gr: TGetResult;
  v: WORD;

  procedure Pass(page_off: DWORD);
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
    c: Integer;

    procedure SetCurrentKey;
    begin
      if FKeyTranslate then begin
        Move(item.key, Srckey, FHead.key_size);
        Srckey[FHead.key_size] := #0;
        TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
        SetString(FCurrentKey, Destkey, FHead.key_size);
      end else
        SetString(FCurrentKey, item.key, FHead.key_size);
      FCurrentRec := item.rec_no;
    end;

  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin
        item := pNTX_ITEM(pChar(page) + page.ref[i]);
        c := CmpKeys(item.key, pChar(FCurrentKey));
        if c <= 0 then begin
          if ( FCurrentRec = item.rec_no ) and ( c = 0 ) then begin
            Found := true;

            if ( item.page = 0 ) then begin
              if ( i <> 0 ) then begin
                gr := grOK;
                item := pNTX_ITEM(pChar(page) + page.ref[i - 1]);
                SetCurrentKey;
              end;
            end else begin

              FNTXBuffers.GetPage(NTXHandler, item.page, page);

              if page.count > 0 then begin
                gr := grOK;
                item := pNTX_ITEM(pChar(page) + page.ref[page.count - 1]);
                SetCurrentKey;
              end else
                gr := grError;
            end;

            Exit;
          end;

          if ( item.page <> 0 ) then Pass(item.page);

          if Found and (gr = grBOF) then begin
            if ( i <> 0 ) then begin
              gr := grOK;
              item := pNTX_ITEM(pChar(page) + page.ref[i - 1]);
              SetCurrentKey;
            end;
            Exit;
          end;
          if gr = grError then Exit;
          if gr = grOK then Exit;

        end;
      end;
    end;
    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);
    if Found and (gr = grBOF ) then begin
      if ( page.count <> 0 ) then begin
        gr := grOK;
        item := pNTX_ITEM(pChar(page) + page.ref[page.count - 1]);
        SetCurrentKey;
      end else
        gr := grError;
    end;
  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  gr := grBOF;
  Found := false;
  Pass(FHead.root);
  Result := gr;

end;

function TNTXIndex.Open: boolean;
begin
  NTXHandler := FileOpen(FNTXFileName, TDBFNTX(FIndexes.Owner).AccessMode.AccessMode);
  if NTXHandler <= 0 then begin
    if (csDesigning in TDBFNTX(FIndexes.Owner).ComponentState) then
      ShowMessage('TNTXIndex: Open error');
  end else begin
    FileSeek(NTXHandler, 0, 0);
    FileRead(NTXHandler, FHead, SizeOf(NTX_HEADER));
    FNTXBuffers.Clear;
    StartUpdate;
    if not ((FHead.sign = 6) or (FHead.sign = 7)) then begin
      FileClose(NTXHandler);
      NTXHandler := -1;
      if (csDesigning in TDBFNTX(FIndexes.Owner).ComponentState) then
        ShowMessage('TNTXIndex: File is not NTX file');
    end;
  end;
  Result := IsOpen;
  if Result then begin
    InternalFirst;
    KeyExpresion := FHead.key_expr;
    ForExpresion := FHead.for_expr;
    if ForExpresion <> '' then
      FForExists := true;
  end;
end;

function TNTXIndex.InternalNext: TGetResult;
var
  Found: Boolean;
  gr: TGetResult;
  v: WORD;

  procedure Pass(page_off: DWORD);
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
    c: Integer;
    level: Integer;

    procedure SetCurrentKey;
    begin
      if FKeyTranslate then begin
        Move(item.key, Srckey, FHead.key_size);
        Srckey[FHead.key_size] := #0;
        TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
        SetString(FCurrentKey, Destkey, FHead.key_size);
      end else
        SetString(FCurrentKey, item.key, FHead.key_size);
      FCurrentRec := item.rec_no;
    end;

    procedure GetFirstFromSubTree(page_off: DWORD);
    begin
      Inc(level);
      try

        FNTXBuffers.GetPage(NTXHandler, page_off, page);

        item := pNTX_ITEM(pChar(page) + page.ref[0]);
        if ( item.page <> 0 ) then begin
          GetFirstFromSubTree(item.page);
          if gr = grOK then Exit;
        end;
        if page.count <> 0 then begin
          SetCurrentKey;
          gr := grOK;
        end else
          if level = 1 then
            gr := grEOF
          else
            gr := grError;
        Exit;
      finally
        Dec(level);
      end;
    end;

  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin
        item := pNTX_ITEM(pChar(page) + page.ref[i]);
        c := CmpKeys(item.key, pChar(FCurrentKey));
        if c <= 0 then begin
          if ( FCurrentRec = item.rec_no ) and ( c = 0 ) then begin
            Found := true;
            //
            SetCurrentKey;
            item := pNTX_ITEM(pChar(page) + page.ref[i + 1]);
            if item.page <> 0 then begin
              level := 0;
              GetFirstFromSubTree(item.page);
            end else begin
              if ( ( i + 1 ) = page.count ) then begin
                gr := grEOF;
              end else begin
                gr := grOK;
                SetCurrentKey;
              end;
            end;
            //
            Exit;
          end;
          if ( item.page <> 0 ) then Pass(item.page);
          if (gr = grOK) then Exit;
          if Found and (gr = grEOF) then begin
            gr := grOK;
            SetCurrentKey;
            Exit;
          end;
          if gr = grError then Exit;
        end;
      end;
    end;
    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);
  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  Found := false;
  gr := grEOF;
  Pass(FHead.root);
  Result := gr;

end;

function TNTXIndex.Seek(Key: String; SoftSeek: boolean = false): boolean;
var
  SoftSeekSet, lResult: boolean;

  procedure Pass(page_off: DWORD);
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        c := CmpKeys(item.key, pChar(Key));

        if c < 0 then begin //Key < Destkey
          if ( item.page <> 0 ) then Pass(item.page);
          if (SoftSeek) and (not lResult) and (not SoftSeekSet) then begin
            TDBFNTX(FIndexes.Owner).RecNo := item.rec_no;
            SoftSeekSet := true;
          end;
          Exit;
        end;

        if c = 0 then begin //Key = Destkey
          TDBFNTX(FIndexes.Owner).RecNo := item.rec_no;
          lResult := true;
          Exit;
        end;

      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page)

  end;

begin

  if FLock then
    try

      ClearIfChange;

      SoftSeekSet := false;
      lResult := false;
      Pass(FHead.root);
      Result := lResult;

    finally
      FUnLock;
    end
  else
    Result := false;

end;

function TNTXIndex.SeekFirstInternal(Key: String; SoftSeek: boolean): boolean;
var
  lResult, SoftSeekSet: boolean;

  procedure Pass(page_off: DWORD);
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin

      item := nil;

      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        c := CmpKeys(item.key, pChar(Key));

        if c < 0 then begin //Key < item.key
          if ( item.page <> 0 ) then Pass(item.page);
          if (SoftSeek) and (not lResult) and (not SoftSeekSet) then begin
            FSeekRecord := item.rec_no;
            SetString(FSeekKey, item.key, FHead.key_size);
            SoftSeekSet := true;
            FSeekOk := true;
          end;
          Exit;
        end;

        if c = 0 then begin //Key = item.key
          if ( item.page <> 0 ) then Pass(item.page);
          if not lResult then begin
            FSeekRecord := item.rec_no;
            SetString(FSeekKey, item.key, FHead.key_size);
            FSeekOk := true;
            lResult := true;
          end;
          Exit;
        end;

      end;

      FSeekRecord := item.rec_no;
      SetString(FSeekKey, item.key, FHead.key_size);
      FSeekOk := true;

    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);

  end;

begin

  FSeekOk := false;

  if FLock then
    try

      ClearIfChange;

      SoftSeekSet := false;
      lResult := false;
      Pass(FHead.root);
      Result := lResult;

    finally
      FUnLock;
    end
  else
    Result := false;

end;

function TNTXIndex.SeekFirst(Key: String; SoftSeek: boolean): boolean;
begin
  Result := SeekFirstInternal(Key, SoftSeek);
  if Result or (SoftSeek and FSeekOk) then
    TDBFNTX(FIndexes.Owner).RecNo := FSeekRecord;
end;

procedure TNTXIndex.SetKeyExpresion(Value: String);
begin
  ChekExpression(Value);
  FKeyExpresion := Value;
  FKeyParser.SetExprParams1(FKeyExpresion, [], [poExtSyntax], '');
end;

procedure TNTXIndex.SetForExpresion(Value: String);
begin
  ChekExpression(Value);
  FForExpresion := Value;
  FForParser.SetExprParams1(FForExpresion, [], [poExtSyntax], '');
end;

procedure TNTXIndex.SetNTXFileName(const Value: String);
var
  PointPos: Integer;
begin
  FNTXFileName := Value;
  FName := ExtractFileName(FNTXFileName);
  PointPos := Pos('.', FName);
  if PointPos <> 0 then
    FName := Copy(FName, 1, PointPos - 1);
end;

function TNTXIndex.SubIndex(LoKey, HiKey: String): boolean;
var
  l, m: Integer;

  function Pass(page_off: DWORD): boolean;
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
    S: String;
  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        c := CmpKeys(item.key, pChar(LoKey), m);

        if c <= 0 then begin //LoKey <= item.key
          if ( item.page <> 0 ) then begin
            Result := Pass(item.page);
            if Result then Exit;
          end;
          c := CmpKeys(item.key, pChar(HiKey), l);
          if c < 0 then begin // HiKey < item.key
            Result := true;
            Exit;
          end;
          if Assigned(OnSubIndex) then begin
            SetString(S, item.key, FHead.key_size);
            OnSubIndex(self, S, item.rec_no);
          end;
        end;

      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);

    Result := false;

  end;

begin

  if FLock then
    try

      ClearIfChange;

      m := Length(LoKey);
      if FHead.key_size < m then m := FHead.key_size;
      l := Length(HiKey);
      if FHead.key_size < l then l := FHead.key_size;
      Pass(FHead.root);
      Result := true;

    finally
      FUnLock;
    end
  else
    Result := false;

end;

function TNTXIndex.SubNtx(var SubNtxFile: String; LoKey, HiKey: String): boolean;
var
  l, m: Integer;
  Accept: boolean;
  Hnd: Integer;
  SHead: NTX_HEADER;

  levels: array [0..10] of NTX_BUFFER;
  cur_lev: Integer;
  max_lev: Integer;
  SubOffSet: DWORD;

  procedure NewPage(lev: Integer);
  var
    item_off: WORD;
    i: Integer;
  begin
    levels[lev].count := 0;
    item_off := ( SHead.max_item * 2 ) + 4;
    for i := 0 to SHead.max_item do begin
      levels[lev].ref[i] := item_off;
      item_off := item_off + SHead.item_size;
    end;
    pNTX_ITEM(pChar(@levels[lev]) + levels[lev].ref[0]).page := 0;
    max_lev := lev;
  end;

  procedure LinkRest;
  var
    page: pNTX_BUFFER;
    i: pNTX_ITEM;
  begin
    Inc(cur_lev);
    if (cur_lev <= max_lev) then begin
      page := pNTX_BUFFER(@levels[cur_lev]);
      if page.count > 0 then begin
        i := pNTX_ITEM(pChar(page) + page.ref[page.count]);
        i.page := SubOffSet;
        SubOffSet := FileSeek(Hnd, 0, 2);
        FileWrite(Hnd, page^, SizeOf(NTX_BUFFER));
      end;
      LinkRest;
    end;
    Dec(cur_lev);
  end;

  procedure AddItem(item: pNTX_ITEM);
  var
    page: pNTX_BUFFER;
    i: pNTX_ITEM;
  begin
    Inc(cur_lev);
    if (cur_lev > max_lev) then NewPage(cur_lev);
    page := pNTX_BUFFER(@levels[cur_lev]);
    if page.count = SHead.max_item then begin
      i := pNTX_ITEM(pChar(page) + page.ref[page.count]);
      if cur_lev <> 0  then
        i.page := item.page
      else
        i.page := 0;
      FileWrite(Hnd, page^, SizeOf(NTX_BUFFER));
      item.page := SubOffSet;
      Inc(SubOffSet, NTX_PAGE);
      AddItem(item);
      page.count := 0;
    end else begin
      if ( cur_lev = 0 ) then item.page := 0;
      Move(item^, (pChar(page) + page.ref[page.count])^, SHead.item_size);
      page.count := page.count + 1;
    end;
    Dec(cur_lev);
  end;

  procedure CreateEmptyIndex;
  begin
    if SubNtxFile = '' then
      SubNtxFile := GetTmpFileName;
    Hnd := FileCreate(SubNtxFile);
    if Hnd <= 0 then begin
      if (csDesigning in TDBFNTX(FIndexes.Owner).ComponentState) then
        ShowMessage('TNTXIndex: SubIndex create error');
    end else begin
      Move(FHead, SHead, SizeOf(NTX_HEADER));
      SHead.root := NTX_PAGE;
      SHead.next_page := 0;
      FileSeek(Hnd, 0, 0);
      FileWrite(Hnd, SHead, SizeOf(NTX_HEADER));
      NewPage(0);
    end;
  end;

  function Pass(page_off: DWORD): boolean;
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    itm: NTX_ITEM;
    c: Integer;
    S: String;
  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        c := CmpKeys(item.key, pChar(LoKey), m);

        if c <= 0 then begin //LoKey <= item.key
          if ( item.page <> 0 ) then begin
            Result := Pass(item.page);
            if Result then Exit;
          end;
          c := CmpKeys(item.key, pChar(HiKey), l);
          if c < 0 then begin // HiKey < item.key
            Result := true;
            Exit;
          end;
          Accept := true;
          if Assigned(OnSubNtx) then begin
            SetString(S, item.key, FHead.key_size);
            OnSubNtx(self, S, item.rec_no, Accept);
          end;
          if Accept then begin
            Move(item^, itm, SHead.item_size);
            AddItem(@itm);
          end;
        end;

      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);

    Result := false;

  end;

begin

  CreateEmptyIndex;
  if Hnd > 0 then
    try

      if FLock then
        try

          ClearIfChange;

          m := Length(LoKey);
          if FHead.key_size < m then m := FHead.key_size;
          l := Length(HiKey);
          if FHead.key_size < l then l := FHead.key_size;
          cur_lev := -1;
          max_lev := -1;
          SubOffSet := NTX_PAGE;
          Pass(FHead.root);
          SubOffSet := 0;
          LinkRest;
          SHead.root := SubOffSet - NTX_PAGE;
          SHead.next_page := 0;
          FileSeek(Hnd, 0, 0);
          FileWrite(Hnd, SHead, SizeOf(NTX_HEADER));

          Result := true;

        finally
          FUnLock;
        end
      else
        Result := false;

    finally

      FileClose(Hnd);

      with FIndexes.Add as TNTXIndex do begin
        Temp := True;
        NTXFileName := SubNtxFile;
        Open;
        Active := true;
        TDBFNTX(FIndexes.Owner).First;
      end;

    end

  else
    Result := false;

end;

procedure TNTXIndex.Last;
begin
  if InternalLast = grOk then
    TDBFNTX(FIndexes.Owner).RecNo := FCurrentRec;
end;

procedure TNTXIndex.Next;
begin
  if InternalNext = grOk then
    TDBFNTX(FIndexes.Owner).RecNo := FCurrentRec;
end;

procedure TNTXIndex.Prior;
begin
  if InternalPrior = grOk then
    TDBFNTX(FIndexes.Owner).RecNo := FCurrentRec;
end;

function TNTXIndex.GetRecordByIndex(GetMode: TGetMode;
  var cRec: Integer): TGetResult;
begin
  Result := grOk;
  case GetMode of
    gmNext:
      begin
        if cRec <> - 1 then
          Result := InternalNext
        else
          Result := InternalFirst;
      end;
    gmPrior:
      begin
        if cRec <> TDBFNTX(FIndexes.Owner).RecordCount then
          Result := InternalPrior
        else
          Result := InternalLast;
      end;
  end;
  if Result = grOk then
    cRec := FCurrentRec;
  if Result = grBOF then
    cRec := -1;
  if Result = grEOF then
    cRec := TDBFNTX(FIndexes.Owner).RecordCount;
  if Result = grError then
    cRec := TDBFNTX(FIndexes.Owner).RecordCount;
end;

function TNTXIndex.GetFirstByIndex(var cRec: Integer): TGetResult;
begin
  Result := InternalFirst;
  cRec := FCurrentRec;
end;

function TNTXIndex.GetLastByIndex(var cRec: Integer): TGetResult;
begin
  Result := InternalLast;
  cRec := FCurrentRec;
end;

function TNTXIndex.SetToRecord: boolean;
begin
  Result := true;
  FCurrentKey := EvaluteKeyExpr;
  FCurrentRec := TDBFNTX(FIndexes.Owner).RecNo;
  if Unique or FForExists then begin
    SeekFirstInternal(FCurrentKey, true);
    if FSeekOk then begin
      if (FCurrentKey <> FSeekKey) then begin
        FCurrentKey := FSeekKey;
        FCurrentRec := FSeekRecord;
      end;
    end else
      Result := false;
  end;
end;

function TNTXIndex.NextBuffer(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): Longint;
var
  lResult: Longint;
  Found: boolean;
  v: WORD;

  function Pass(page_off: DWORD): boolean;
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
    l: Integer;

  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin
        item := pNTX_ITEM(pChar(page) + page.ref[i]);
        c := CmpKeys(item.key, pChar(FCurrentKey));
        if c <= 0 then begin //FCurrentKey <= item.key
          if ( item.page <> 0 ) then begin
            Result := Pass(item.page);
            if Result then Exit;
          end;
          //
          if Found then begin
            if NTXRange.Active then begin
              l := Length(NTXRange.LoKey);
              if l > 0 then begin
                c := CmpKeys(item.key, pChar(NTXRange.LoKey), l);
                if c < 0 then begin //NTXRange.LoKey < item.key
                  Result := true;
                  Exit;
                end;
              end;
            end;
            pLongint(pChar(FBufInd) + lResult * SizeOf(Longint))^ := item.rec_no;
            FileSeek(DBFHandler, data_offset + (item.rec_no - 1) * DWORD(FRecordSize), soFromBeginning);
            FileRead(DBFHandler, (FBuffer + lResult * FRecordSize)^, FRecordSize);
            Inc(lResult);
          end;
          //
          if lResult = FRecordsPerBuf then begin
            Result := true;
            Exit;
          end;

          if ( FCurrentRec = item.rec_no ) and ( c = 0 ) then Found := true;

        end;

      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then begin
      Result := Pass(item.page);
      if Result then Exit;
    end;

    Result := false;

  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  lResult := 0;
  Found := false;
  Pass(FHead.root);
//  if not Found then
//    beep;
  Result := lResult;

end;

function TNTXIndex.PriorBuffer(DBFHandler: Integer; FBuffer: pChar; FRecordsPerBuf: Integer; FRecordSize: Integer; FBufInd: pLongint; data_offset: Word): Longint;
var
  lResult: Longint;
  bResult: boolean;
  Found: boolean;
  v: WORD;

  procedure Pass(page_off: DWORD);
  var
    k, i: Integer;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
  label
    a1;

  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    k := page.count;
    if not Found then begin
      if page.count > 0 then begin
        for i := 0 to page.count - 1 do begin
          k := i - 1;
          item := pNTX_ITEM(pChar(page) + page.ref[i]);
          c := CmpKeys(item.key, pChar(FCurrentKey));
          if c <= 0 then begin //FCurrentKey <= item.key
            if ( FCurrentRec = item.rec_no ) and ( c = 0 ) then Found := true;
            if ( item.page <> 0 ) then begin
              Pass(item.page);
              if bResult then Exit;
            end;
            if Found then goto a1;
          end;
        end;
      end;
      item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
      if ( item.page <> 0 ) then begin
        Pass(item.page);
        if bResult then Exit;
        k := page.count - 1;
        if Found then goto a1;
      end;
    end;
    //
    a1:
    if Found then begin
      while k >= 0 do begin
        item := pNTX_ITEM(pChar(page) + page.ref[k]);
        if k < page.count then begin
          if NTXRange.Active then begin
            c := CmpKeys(item.key, pChar(NTXRange.HiKey));
            if c > 0 then begin //NTXRange.HiKey > item.key
              bResult := true;
              Exit;
            end;
          end;
          pLongint(pChar(FBufInd) + (FRecordsPerBuf - lResult - 1) * SizeOf(Longint))^ := item.rec_no;
          FileSeek(DBFHandler, data_offset + (item.rec_no - 1) * DWORD(FRecordSize), soFromBeginning);
          FileRead(DBFHandler, (FBuffer + (FRecordsPerBuf - lResult - 1) * FRecordSize)^, FRecordSize);
          Inc(lResult);
          if lResult = FRecordsPerBuf then begin
            bResult := true;
            Exit;
          end;
        end;
        if ( item.page <> 0 ) then begin
          Pass(item.page);
          if bResult then Exit;
        end;
        Dec(k);
      end;
    end;
    //
  end;

begin

  v := FHead.version;
  FileSeek(NTXHandler, 0, 0);
  FileRead(NTXHandler, FHead, 12);
  if v <> FHead.version then FNTXBuffers.Clear;

  lResult := 0;
  bResult := false;
  Found := false;
  Pass(FHead.root);
//  if not Found then
//    beep;
  Result := lResult;

end;

function TNTXIndex.SetToRecord(Key: String; Rec: Integer): boolean;
begin
  Result := true;
  FCurrentKey := Key;
  FCurrentRec := Rec;
  if Unique or FForExists then begin
    SeekFirstInternal(FCurrentKey, true);
    if FSeekOk then begin
      if (FCurrentKey <> FSeekKey) then begin
        FCurrentKey := FSeekKey;
        FCurrentRec := FSeekRecord;
      end;
    end else
      Result := false;
  end;
end;

function TNTXIndex.GetCurrentKey: String;
begin
  Result := FCurrentKey;
end;

function TNTXIndex.GetCurrentRec: DWORD;
begin
  Result := FCurrentRec;
end;

function TNTXIndex.FillFirstBufRecords(DBFHandler: Integer; FBuffer: pChar;
  FRecordsPerBuf, FRecordSize: Integer;
  FBufInd: pLongInt; data_offset: Word): longint;
var
  lResult: longint;
  c, l: Integer;
  v: WORD;

  function Pass(page_off: DWORD): boolean;
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
  begin

    //FileSeek(NTXHandler, page_off, 0);
    //FileRead(NTXHandler, page, SizeOf(NTX_BUFFER));

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        if ( item.page <> 0 ) then begin
          Result := Pass(item.page);
          if Result then Exit;
        end;
        //
        pLongint(pChar(FBufInd) + lResult * SizeOf(Longint))^ := item.rec_no;
        FileSeek(DBFHandler, data_offset + (item.rec_no - 1) * DWORD(FRecordSize), soFromBeginning);
        FileRead(DBFHandler, (FBuffer + lResult * FRecordSize)^, FRecordSize);
        Inc(lResult);
        //
        if lResult = FRecordsPerBuf then begin
          Result := true;
          Exit;
        end;

      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then
      Result := Pass(item.page)
    else
      Result := false;

  end;

begin

  if not NTXRange.Active then begin

    v := FHead.version;
    FileSeek(NTXHandler, 0, 0);
    FileRead(NTXHandler, FHead, 12);
    if v <> FHead.version then FNTXBuffers.Clear;

    lResult := 0;
    Pass(FHead.root);
    Result := lResult;

  end else begin
    SeekFirstInternal(NTXRange.HiKey, true);
    if FSeekOk then begin
      l := Length(NTXRange.LoKey);
      c := CmpKeys2(pChar(NTXRange.LoKey), pChar(FSeekKey), l);
      if (l > 0) and (c <= 0) then begin
        FCurrentKey := FSeekKey;
        FCurrentRec := FSeekRecord;
        pLongint(FBufInd)^ := FSeekRecord;
        FileSeek(DBFHandler, data_offset + (DWORD(FSeekRecord) - 1) * DWORD(FRecordSize), soFromBeginning);
        FileRead(DBFHandler, FBuffer^, FRecordSize);
        Result := 1 + NextBuffer(DBFHandler, FBuffer + FRecordSize, FRecordsPerBuf - 1, FRecordSize, pLongint(pChar(FBufInd) + SizeOf(Longint)), data_offset);
      end else
        Result := 0;
    end else
      Result := 0;
  end;

end;

function TNTXIndex.FillLastBufRecords(DBFHandler: Integer; FBuffer: pChar;
  FRecordsPerBuf, FRecordSize: Integer; FBufInd: pLongint;
  data_offset: Word): longint;
var
  lResult: longint;
  c, l: Integer;
  v: WORD;

  function Pass(page_off: DWORD): boolean;
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
  begin

    //FileSeek(NTXHandler, page_off, 0);
    //FileRead(NTXHandler, page, SizeOf(NTX_BUFFER));

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then begin
      Result := Pass(item.page);
      if Result then Exit;
    end;

    if page.count > 0 then begin
      for i := page.count - 1 downto 0 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        //
        pLongint(pChar(FBufInd) + (FRecordsPerBuf - lResult - 1) * SizeOf(Longint))^ := item.rec_no;
        FileSeek(DBFHandler, data_offset + (item.rec_no - 1) * DWORD(FRecordSize), soFromBeginning);
        FileRead(DBFHandler, (FBuffer + (FRecordsPerBuf - lResult - 1) * FRecordSize)^, FRecordSize);
        Inc(lResult);
        //

        if lResult = FRecordsPerBuf then begin
          Result := true;
          Exit;
        end;

        if ( item.page <> 0 ) then begin
          Result := Pass(item.page);
          if Result then Exit;
        end;

      end;
    end;

    Result := false;

  end;

begin

  if (not NTXRange.Active) or (NTXRange.LoKey  = '') then begin

    v := FHead.version;
    FileSeek(NTXHandler, 0, 0);
    FileRead(NTXHandler, FHead, 12);
    if v <> FHead.version then FNTXBuffers.Clear;

    lResult := 0;
    Pass(FHead.root);
    Result := lResult;

  end else begin
    SeekLastInternal(NTXRange.LoKey, true);
    if FSeekOk then begin
      l := Length(NTXRange.HiKey);
      c := CmpKeys2(pChar(NTXRange.HiKey), pChar(FSeekKey), l);
      if (l > 0) and (c >= 0) then begin
        FCurrentKey := FSeekKey;
        FCurrentRec := FSeekRecord;
        pLongint(pChar(FBufInd) + (FRecordsPerBuf - 1) * SizeOf(Longint))^ := FCurrentRec;
        FileSeek(DBFHandler, data_offset + (FCurrentRec - 1) * DWORD(FRecordSize), soFromBeginning);
        FileRead(DBFHandler, (FBuffer + (FRecordsPerBuf - 1) * FRecordSize)^, FRecordSize);
        Result := 1 + PriorBuffer(DBFHandler, FBuffer, FRecordsPerBuf - 1, FRecordSize, FBufInd, data_offset);
      end else
        Result := 0;
    end else
      Result := 0;
  end;

end;

function TNTXIndex.SetToRecord(Rec: Integer): boolean;
begin
  Result := true;
  FCurrentKey := EvaluteKeyExpr;
  FCurrentRec := Rec;
  if Unique or FForExists then begin
    SeekFirstInternal(FCurrentKey, true);
    if FSeekOk then begin
      if (FCurrentKey <> FSeekKey) then begin
        FCurrentKey := FSeekKey;
        FCurrentRec := FSeekRecord;
      end;
    end else
      Result := false;
  end;
end;

function TNTXIndex.FileWrite(Handle: Integer; const Buffer;
  Count: LongWord): Integer;
var
  i: Integer;
  l: boolean;
  Ok: boolean;
  oW: TDBFNTX;
begin
  i := 0;
  oW := TDBFNTX(FIndexes.Owner);
  l := (( (oW.AccessMode.FLast and fmShareExclusive) = fmShareExclusive ) or ( (oW.AccessMode.FLast and fmShareDenyWrite) = fmShareDenyWrite ));
  repeat
    Result := SysUtils.FileWrite(Handle, Buffer, Count);
    Ok := (Result <> -1);
    if not Ok then begin
      if l then
        Ok := true
      else begin
        Wait(0.001, false);
        Inc(i);
        if i = oW.WaitBusyRes then Ok := true;
      end;
    end;
  until Ok;
end;

function TNTXIndex.FileRead(Handle: Integer; var Buffer;
  Count: LongWord): Integer;
var
  i: Integer;
  l: boolean;
  Ok: boolean;
  oW: TDBFNTX;
begin
  i := 0;
  oW := TDBFNTX(FIndexes.Owner);
  l := (( (oW.AccessMode.FLast and fmShareExclusive) = fmShareExclusive ) or ( (oW.AccessMode.FLast and fmShareDenyWrite) = fmShareDenyWrite ));
  repeat
    Result := SysUtils.FileRead(Handle, Buffer, Count);
    Ok := (Result <> -1);
    if not Ok then begin
      if l then
        Ok := true
      else begin
        Wait(0.001, false);
        Inc(i);
        if i = oW.WaitBusyRes then Ok := true;
      end;
    end;
  until Ok;
end;

function TNTXIndex.CompareKeys(S1, S2: PChar; MaxLen: Cardinal): Integer;
var
  i: Integer;
  T1: array [0..NTX_PAGE] of Char;
  T2: array [0..NTX_PAGE] of Char;
begin
  //S1 - CurrentKey
  //S2 - Item Key
  if Assigned(OnCompareKeys) then begin
    OnCompareKeys(self, S1, S2, MaxLen, Result);
  end else begin
    if FCl501Rus then begin
      Result := 0;
      CharToOem(pChar(S1), T1);
      CharToOem(pChar(S2), T2);
      for i := 0 to MaxLen - 1 do begin
        Result := CL501RUSORDER[Ord(T1[i])] - CL501RUSORDER[Ord(T2[i])];
        if Result <> 0 then Exit;
      end;
    end else begin
      //Result := AnsiStrLComp(S1, S2, MaxLen);  - in Win95-98 not currect
      Result := StrLComp(S1, S2, MaxLen);
    end;
  end;
end;

function TNTXIndex.GetFreePage: DWORD;
var
  page: pNTX_BUFFER;
  i: Integer;
  Ind: TNTXBuffer;
  item_off: WORD;
begin
  if FHead.next_page <> 0 then begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, FHead.next_page, page);

    page.count := 0;
    Result := FHead.next_page;
    FHead.next_page := pNTX_ITEM(pChar(page) + page.ref[page.count]).page;
    pNTX_ITEM(pChar(page) + page.ref[page.count]).page := 0;

    Ind.Fchanged := true;

  end else begin

    Result := FLastOffset;

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, Result, page, false);

    page.count := 0;
    item_off := ( FHead.max_item * 2 ) + 4;
    for i := 0 to FHead.max_item do begin
      page.ref[i] := item_off;
      item_off := item_off + FHead.item_size;
    end;
    pNTX_ITEM(pChar(page) + page.ref[0]).page := 0;

    Inc(FLastOffset, SizeOf(NTX_BUFFER));

    Ind.Fchanged := true;

  end;
end;

function TNTXIndex.AddItem(ntxItem: pNTX_ITEM): boolean;
var
  NewPage: pNTX_BUFFER;
  _NewPageOff, NewPageOff: DWORD;
  ItemHasBeenAdded: boolean;
  rf: WORD;
  Ind: TNTXBuffer;

  procedure AddItemInternal(page_off: DWORD);
  var
    i, j, beg, Mid: Integer;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
    Ind, Ind1: TNTXBuffer;

    procedure InsItem(page: pNTX_BUFFER);
    begin
      j := page.count;
      while j >= i do begin
        rf := page.ref[j + 1];
        page.ref[j + 1] := page.ref[j];
        page.ref[j] := rf;
        Dec(j);
      end;
      page.count := page.count + 1;
      Move(ntxItem.key, pNTX_ITEM(pChar(page) + page.ref[i]).key, FHead.key_size);
      pNTX_ITEM(pChar(page) + page.ref[i]).rec_no := ntxItem.rec_no;
      pNTX_ITEM(pChar(page) + page.ref[i]).page := ntxItem.page;
      if ( ntxItem.page <> 0 ) then begin
        pNTX_ITEM(pChar(page) + page.ref[i + 1]).page := NewPageOff;
        NewPageOff := 0;
      end;
    end;

    procedure CmpRec;
    begin
      if c = 0 then begin
        if item.rec_no < ntxItem.rec_no then
          c := 1
        else
          c := -1;
      end;
    end;

  begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, page_off, page);

    i := page.count;
    if ( i > 0 ) then begin
      beg := 0;
      item := pNTX_ITEM(pChar(page) + page.ref[beg]);
      c := CmpKeys1(item.key, pChar(@ntxItem^.key[0]));

      CmpRec;

      if ( c > 0 ) then begin
        repeat
          Mid := (i+beg) div 2;
          item := pNTX_ITEM(pChar(page) + page.ref[Mid]);
          c := CmpKeys1(item.key, pChar(@ntxItem^.key[0]));

          CmpRec;

          if ( c > 0 ) then
             beg := Mid
          else
             i := Mid;
        until ( ((i-beg) div 2) = 0 );
      end else
        i := beg;
    end;
    item := pNTX_ITEM(pChar(page) + page.ref[i]);
    if ( item.page <> 0 ) then AddItemInternal(item.page);
    if not ItemHasBeenAdded then begin
      if (page.count = FHead.max_item) then begin
        _NewPageOff := GetFreePage;

        Ind1 := FNTXBuffers.GetNTXBuffer(NTXHandler, _NewPageOff, NewPage);

        Move(page^, NewPage^, SizeOf(NTX_BUFFER));
        page.count := FHead.half_page;
        for j := FHead.half_page to NewPage.count do begin
          rf := NewPage.ref[j - FHead.half_page];
          NewPage.ref[j - FHead.half_page] := NewPage.ref[j];
          NewPage.ref[j] := rf;
        end;
        NewPage.count := NewPage.count - FHead.half_page;
        if i < FHead.half_page then begin
          InsItem(page);
        end else begin
          i := i - FHead.half_page;
          InsItem(NewPage);
        end;
        NewPageOff := _NewPageOff;
        if page.count >= NewPage.count then begin
          page.count := page.count - 1;
          Move(pNTX_ITEM(pChar(page) + page.ref[page.count]).key, ntxItem.key, FHead.key_size);
          ntxItem.rec_no := pNTX_ITEM(pChar(page) + page.ref[page.count]).rec_no;
        end else begin
          Move(pNTX_ITEM(pChar(NewPage) + NewPage.ref[0]).key, ntxItem.key, FHead.key_size);
          ntxItem.rec_no := pNTX_ITEM(pChar(NewPage) + NewPage.ref[0]).rec_no;
          for j := 0 to NewPage.count do begin
            rf := NewPage.ref[j];
            NewPage.ref[j] := NewPage.ref[j + 1];
            NewPage.ref[j + 1] := rf;
          end;
          NewPage.count := NewPage.count - 1;
        end;
        ntxItem.page := page_off;

        Ind.Fchanged := true;

        Ind1.Fchanged := true;

        ItemHasBeenAdded := false;
      end else begin
        InsItem(page);

        Ind.Fchanged := true;

        ItemHasBeenAdded := true;
      end;
    end;
  end;

begin

  NewPageOff := 0;
  ItemHasBeenAdded := false;

  AddItemInternal(FHead.root);

  if not ItemHasBeenAdded then begin
    _NewPageOff := GetFreePage;
    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, _NewPageOff, NewPage);
    NewPage.count := 1;
    Move(ntxItem.key, pNTX_ITEM(pChar(NewPage) + NewPage.ref[0]).key, FHead.key_size);
    pNTX_ITEM(pChar(NewPage) + NewPage.ref[0]).rec_no := ntxItem.rec_no;
    pNTX_ITEM(pChar(NewPage) + NewPage.ref[0]).page := ntxItem.page;
    pNTX_ITEM(pChar(NewPage) + NewPage.ref[1]).page := NewPageOff;
    FHead.root := _NewPageOff;

    Ind.Fchanged := true;

    ItemHasBeenAdded := true;

  end;
  Result := ItemHasBeenAdded;

end;

procedure TNTXIndex.AddKey(sKey: String; nRec: Integer);
var
  item: NTX_ITEM;
  AddOk: boolean;
begin
  AddOk := true;
  if Unique then
    AddOk := AddOk and (not SeekFirstInternal(sKey));
  if FForExists then
    AddOk := AddOk and (FForParser.Execute);
  if AddOk then begin
    item.page := 0;
    item.rec_no := nRec;
    Move(pChar(sKey)^, item.key, FHead.key_size);
    TransKey(item.key);
    AddItem(@item);
  end;
end;

procedure TNTXIndex.DeleteKey(sKey: String; nRec: Integer);
var
  FLastKey: String;
  FLastRec: DWORD;
  rf: WORD;

  procedure AddInEndItem(page_off: DWORD; itemKey: pChar; itemRec: DWORD);
  var
    page: pNTX_BUFFER;
    NewPage: pNTX_BUFFER;
    item: pNTX_ITEM;
    NewPageOff: DWORD;
    i: DWORD;
    Ind, Ind1: TNTXBuffer;
  begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, page_off, page);

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then
      AddInEndItem(item.page, itemKey, itemRec)
    else begin
      if page.count < FHead.max_item then begin
        Move(itemKey^, pNTX_ITEM(pChar(page) + page.ref[page.count]).key, FHead.key_size);
        pNTX_ITEM(pChar(page) + page.ref[page.count]).rec_no := itemRec;
        pNTX_ITEM(pChar(page) + page.ref[page.count]).page := 0;
        page.count := page.count + 1;
        pNTX_ITEM(pChar(page) + page.ref[page.count]).page := 0;

        Ind.Fchanged := true;

      end else begin
        NewPageOff := GetFreePage;

        Ind1 := FNTXBuffers.GetNTXBuffer(NTXHandler, NewPageOff, NewPage);

        Move(page^, NewPage^, SizeOf(NTX_BUFFER));
        page.count := FHead.half_page;
        pNTX_ITEM(pChar(page) + page.ref[FHead.half_page]).page := NewPageOff;

        Ind.Fchanged := true;

        for i := FHead.half_page to NewPage.count do begin
          rf := NewPage.ref[i - FHead.half_page];
          NewPage.ref[i - FHead.half_page] := NewPage.ref[i];
          NewPage.ref[i] := rf;
        end;
        NewPage.count := NewPage.count - FHead.half_page;
        Move(itemKey^, pNTX_ITEM(pChar(NewPage) + NewPage.ref[NewPage.count]).key, FHead.key_size);
        pNTX_ITEM(pChar(NewPage) + NewPage.ref[NewPage.count]).rec_no := itemRec;
        pNTX_ITEM(pChar(NewPage) + NewPage.ref[NewPage.count]).page := 0;
        NewPage.count := NewPage.count + 1;

        Ind1.Fchanged := true;

      end;
    end;
  end;

  procedure DeletePage(page_off: DWORD);
  var
    page: pNTX_BUFFER;
    Ind: TNTXBuffer;
  begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, page_off, page);

    page.count := 0;
    pNTX_ITEM(pChar(page) + page.ref[0]).page := FHead.next_page;

    Ind.Fchanged := true;

    FHead.next_page := page_off;

  end;

  procedure GetLastItem(page_off: DWORD; PrePage: pNTX_BUFFER; PrePageOffset: DWORD; PreItemRef: WORD);
  var
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
    Ind: TNTXBuffer;
  begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, page_off, page);

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then
      GetLastItem(item.page, page, page_off, page.count)
    else begin
      //
      item := pNTX_ITEM(pChar(page) + page.ref[page.count - 1]);
      if FKeyTranslate then begin
        Move(item.key, Srckey, FHead.key_size);
        Srckey[FHead.key_size] := #0;
        TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
        SetString(FLastKey, Destkey, FHead.key_size);
      end else
        SetString(FLastKey, item.key, FHead.key_size);
      FLastRec := item.rec_no;
      //
      page.count := page.count - 1;

      Ind.Fchanged := true;

    end;
    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( page.count = 0 ) and ( item.page = 0 ) then begin
      DeletePage(page_off);
      pNTX_ITEM(pChar(PrePage) + NTX_BUFFER(PrePage^).ref[PreItemRef])^.page := 0;

      FNTXBuffers.SetPage(NTXHandler, PrePageOffset, PrePage);

    end;
  end;

  function Pass(page_off: DWORD; LastItemRef: WORD; LastPage: pNTX_BUFFER; LastPageOffset: DWORD): boolean;
  var
    i, j: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    item1: pNTX_ITEM;
    c: Integer;
    Ind: TNTXBuffer;

    function DelPage: boolean;
    begin
      Result := false;
      if page.count = 0 then begin
        item1 := pNTX_ITEM(pChar(page) + page.ref[0]);
        if ( item1.page = 0 ) then begin
          if LastPage <> nil then begin
            pNTX_ITEM(pChar(LastPage) + NTX_BUFFER(LastPage^).ref[LastItemRef])^.page := 0;
            DeletePage(page_off);

            FNTXBuffers.SetPage(NTXHandler, LastPageOffset, LastPage);

            Result := true;
          end;
        end;
      end;
    end;

  begin

    Ind := FNTXBuffers.GetNTXBuffer(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin
        item := pNTX_ITEM(pChar(page) + page.ref[i]);
        c := CmpKeys(item.key, pChar(sKey));
        if c <= 0 then begin //sKey <= item.key

          if ( item.page <> 0 ) then begin
            Result := Pass(item.page, i, page, page_off);
            DelPage;
            if Result then Exit;
          end;

          if ( DWORD(nRec) = item.rec_no ) and ( c = 0 ) then begin
            if ( item.page = 0 ) then begin
              j := i;
              while j < page.count do begin
                rf := page.ref[j];
                page.ref[j] := page.ref[j + 1];
                page.ref[j + 1] := rf;
                Inc(j);
              end;
              if page.count > 0 then begin
                page.count := page.count - 1;

                Ind.Fchanged := true;

              end;
              DelPage;
              Result := true;
            end else begin
              GetLastItem(item.page, page, page_off, i);
              Move(pChar(FLastKey)^, pNTX_ITEM(pChar(page) + page.ref[i]).key, FHead.key_size);
              pNTX_ITEM(pChar(page) + page.ref[i]).rec_no := FLastRec;

              Ind.Fchanged := true;

              Result := true;
            end;
            Exit;
          end;

        end;
      end;
    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then begin
      Result := Pass(item.page, page.count, page, page_off);
      DelPage;
      if Result then Exit;
    end;

    Result := false;

  end;

begin

  Pass(FHead.root, 0, nil, 0);

end;

function TNTXIndex.LastKey(out LastKey: String; out LastRec: Integer): boolean;
var
  level: Integer;

  function Pass(page_off: DWORD): TGetResult;
  var
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    Srckey: array[0..NTX_PAGE-1] of Char;
    Destkey: array[0..NTX_PAGE-1] of Char;
  begin
    Inc(level);
    try

      //FileSeek(NTXHandler, page_off, 0);
      //FileRead(NTXHandler, page, SizeOf(NTX_BUFFER));

      FNTXBuffers.GetPage(NTXHandler, page_off, page);

      item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
      if ( item.page <> 0 ) then begin
        Result := Pass(item.page);
        if Result = grOK then Exit;
      end;
      if page.count <> 0 then begin
        //
        item := pNTX_ITEM(pChar(page) + page.ref[page.count - 1]);
        if FKeyTranslate then begin
          Move(item.key, Srckey, FHead.key_size);
          Srckey[FHead.key_size] := #0;
          TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
          SetString(LastKey, Destkey, FHead.key_size);
        end else
          SetString(LastKey, item.key, FHead.key_size);
        LastRec := item.rec_no;
        //
        Result := grOK;
      end else
        if level = 1 then
          Result := grBOF
        else
          Result := grError;
      Exit;
    finally
      Dec(level);
    end;
  end;

begin

  if FLock then
    try

      ClearIfChange;

      level := 0;
      Result := (Pass(FHead.root) = grOK);
    finally
      FUnLock;
    end
  else
    Result := false;

end;

function TNTXIndex.FLock: boolean;
var
  i: Integer;
  l: boolean;
  oW: TDBFNTX;
begin
  if not FFileLock then begin
    i := 0;
    oW := TDBFNTX(FIndexes.Owner);
    l := ( ( (oW.AccessMode.FLast and fmShareExclusive) = fmShareExclusive ) or ( (oW.AccessMode.FLast and fmShareDenyWrite) = fmShareDenyWrite ) or FFileLock );
    repeat
      if not l then begin
        Result := FileLock(NTXHandler, 1000000000, 1);
        if not Result then begin
          Wait(0.001, false);
          Inc(i);
          if i = oW.WaitBusyRes then Exit;
        end;
      end else
        Result := true;
    until Result;
    FFileLock := Result;
  end else
    Result := true;
end;

function TNTXIndex.FUnLock: boolean;
var
  l: boolean;
  oW: TDBFNTX;
begin
  oW := TDBFNTX(FIndexes.Owner);
  l := ( ( (oW.AccessMode.FLast and fmShareExclusive) = fmShareExclusive ) or ( (oW.AccessMode.FLast and fmShareDenyWrite) = fmShareDenyWrite ) );
  if not l then
    Result := FileUnLock(NTXHandler, 1000000000, 1)
  else
    Result := true;
  FFileLock := not Result;
end;

procedure TNTXIndex.SetUnique(const Value: boolean);
begin
  if Value then
    FHead.unique := #1
  else
    FHead.unique := #0;
end;

function TNTXIndex.GetUnique: boolean;
begin
  Result := (FHead.unique <> #0);
end;

procedure TNTXIndex.SetDesc(const Value: boolean);
begin
  if Value then
    FHead.Desc := #1
  else
    FHead.Desc := #0;
end;

function TNTXIndex.GetDesc: boolean;
begin
  Result := (FHead.Desc <> #0);
end;

function TNTXIndex.GetOrder: String;
var
  i: Integer;
  p: pChar;
begin
  for i := 0 to 7 do
    if FHead.order[i] = #0 then break;
  p := pChar(@FHead.order[0]);
  SetString(Result, p, i);
  ChekExpression(Result);
  if Result = '' then Result := Name;
end;

procedure TNTXIndex.SetOrder(Value: String);
var
  i, j: Integer;
begin
  ChekExpression(Value);
  j := Length(Value);
  if j > 8 then j := 8;
  for i := 0 to j - 1 do
    FHead.order[i] := Value[i + 1];
  FHead.order[j] := #0;
end;

procedure TNTXIndex.ChekExpression(var Value: String);
var
  i, j: Integer;
begin
  j := Length(Value);
  for i := 1 to j do
    if Value[i] < #32 then begin
      Value := '';
      Exit;
    end;
end;

function TNTXIndex.CmpKeys1(ItemKey, CurrKey: pChar; KSize: Integer): Integer;
var
  Srckey: array[0..NTX_PAGE-1] of Char;
  Destkey1, Destkey2: array[0..NTX_PAGE-1] of Char;
begin
  if KSize = 0 then KSize := FHead.key_size;
  if FKeyTranslate then begin
    Move(ItemKey^, Srckey, KSize);
    Srckey[KSize] := #0;
    TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey1, false);
    Move(CurrKey^, Srckey, KSize);
    Srckey[KSize] := #0;
    TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey2, false);
    Result := CompareKeys(Destkey2, Destkey1, KSize);
  end else
    Result := CompareKeys(CurrKey, ItemKey, KSize);
  if Desc then Result := - Result;
end;

function TNTXIndex.CmpKeys2(ItemKey, CurrKey: pChar; KSize: Integer): Integer;
var
  Srckey: array[0..NTX_PAGE-1] of Char;
  Destkey1, Destkey2: array[0..NTX_PAGE-1] of Char;
begin
  if KSize = 0 then KSize := FHead.key_size;
  if FKeyTranslate then begin
    Move(ItemKey^, Destkey1, KSize);
    //Move(ItemKey^, Srckey, KSize);
    //Srckey[KSize] := #0;
    //TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey1, false);
    Move(CurrKey^, Srckey, KSize);
    Srckey[KSize] := #0;
    TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey2, false);
    Result := CompareKeys(Destkey2, Destkey1, KSize);
  end else
    Result := CompareKeys(CurrKey, ItemKey, KSize);
  if Desc then Result := - Result;
end;

function TNTXIndex.CmpKeys(ItemKey, CurrKey: pChar; KSize: Integer = 0): Integer;
var
  Srckey: array[0..NTX_PAGE-1] of Char;
  Destkey: array[0..NTX_PAGE-1] of Char;
begin
  if KSize = 0 then KSize := FHead.key_size;
  if FKeyTranslate then begin
    Move(ItemKey^, Srckey, KSize);
    Srckey[KSize] := #0;
    TDBFNTX(FIndexes.Owner).Translate(Srckey, Destkey, false);
    Result := CompareKeys(CurrKey, Destkey, KSize);
  end else
    Result := CompareKeys(CurrKey, ItemKey, KSize);
  if Desc then Result := - Result;
end;

procedure TNTXIndex.TransKey(Key: pChar; KSize: Integer = 0);
var
  Srckey: array[0..NTX_PAGE-1] of Char;
begin
  if KSize = 0 then KSize := FHead.key_size;
  if FKeyTranslate then begin
    Move(Key^, Srckey, KSize);
    Srckey[KSize] := #0;
    TDBFNTX(FIndexes.Owner).Translate(Srckey, Key, true);
  end;
end;

procedure TNTXIndex.CreateIndex;
const
  DBF_BUFFER_SIZE = 4096;
var
  oB: TDBFNTX;
  DBFBuffer: pChar;
  RecPareBuf: Integer;
  ReadSize, RealRead, BufCnt: Integer;
  i: Integer;
  Key: String;
  Rec: DWORD;

  procedure CreateEmptyIndex;
  //var
  //  i: Integer;
  begin
    if not FReindex then begin
      NTXHandler := FileCreate(FNTXFileName);
      if NTXHandler <= 0 then begin
        if (csDesigning in TDBFNTX(FIndexes.Owner).ComponentState) then
          ShowMessage('TNTXIndex: Create error');
      end else begin
        FNTXBuffers.Clear;
        if FClipperVer in [v500, v501] then
          FHead.sign := 6
        else
          FHead.sign := 7;
        FHead.version := 1;
        FHead.root := NTX_PAGE;
        FHead.next_page := 0;
        FHead.key_size := Length(FKeyParser.Key);;
        FHead.item_size := FHead.key_size + 8;
        FHead.key_dec := FKeyParser.Prec;
        FHead.max_item := (NTX_PAGE - FHead.item_size - 4) div (FHead.item_size + 2);
        FHead.half_page := FHead.max_item div 2;
        FHead.max_item := FHead.half_page * 2;
        System.Move(pChar(FKeyExpresion)^, FHead.key_expr, Length(FKeyExpresion));
        FHead.key_expr[Length(FKeyExpresion)] := #0;
        //FHead.unique := #0;
        FHead.reserv1 := #0;
        //FHead.desc := #0;
        FHead.reserv3 := #0;
        System.Move(pChar(FForExpresion)^, FHead.for_expr, Length(FForExpresion));
        FHead.for_expr[Length(FForExpresion)] := #0;
        //for i := 0 to 7 do FHead.order[i] := #0;
        //for i := 0 to 477 do FHead.Rest[i] := #0;
        FileSeek(NTXHandler, 0, 0);
        FileWrite(NTXHandler, FHead, SizeOf(NTX_HEADER));
        FLastOffset := SizeOf(NTX_HEADER);
        GetFreePage;
      end;
    end else begin
      //Truncate ntx file
      FileSeek(NTXHandler, 0, 0);
      SetEndOfFile(NTXHandler);
      //Create new header
      FNTXBuffers.Clear;
      if FClipperVer in [v500, v501] then
        FHead.sign := 6
      else
        FHead.sign := 7;
      FHead.version := 1;
      FHead.root := NTX_PAGE;
      FHead.next_page := 0;
      //FHead.key_size := Length(FKeyParser.Key);;
      //FHead.item_size := FHead.key_size + 8;
      //FHead.key_dec := FKeyParser.Prec;
      //FHead.max_item := (NTX_PAGE - FHead.item_size - 4) div (FHead.item_size + 2);
      //FHead.half_page := FHead.max_item div 2;
      //FHead.max_item := FHead.half_page * 2;
      //System.Move(pChar(FKeyExpresion)^, FHead.key_expr, Length(FKeyExpresion));
      //FHead.key_expr[Length(FKeyExpresion)] := #0;
      //FHead.unique := #0;
      FHead.reserv1 := #0;
      //FHead.desc := #0;
      FHead.reserv3 := #0;
      //System.Move(pChar(FForExpresion)^, FHead.for_expr, Length(FForExpresion));
      //FHead.for_expr[Length(FForExpresion)] := #0;
      //for i := 0 to 7 do FHead.order[i] := #0;
      //for i := 0 to 477 do FHead.Rest[i] := #0;
      FileSeek(NTXHandler, 0, 0);
      FileWrite(NTXHandler, FHead, SizeOf(NTX_HEADER));
      FLastOffset := SizeOf(NTX_HEADER);
      GetFreePage;
    end;
  end;

begin
  oB := TDBFNTX(FIndexes.Owner);
  if oB.Active then begin
    oB.IndState := true;
    FCreateIndexProc:= true;
    DBFBuffer := MemMgr.oMem.GetMem(self, DBF_BUFFER_SIZE);
    try

      FillChar(DBFBuffer^, DBF_BUFFER_SIZE, ' ');
      oB.IndRecBuf := DBFBuffer;
      EvaluteKeyExpr;
      CreateEmptyIndex;

      RecPareBuf := DBF_BUFFER_SIZE div oB.Header.rec_size;
      if RecPareBuf >= 1 then begin
        ReadSize := RecPareBuf * oB.Header.rec_size;
        SysUtils.FileSeek(oB.Handle, oB.Header.data_offset, 0);
        Rec := 0;
        repeat
          RealRead := SysUtils.FileRead(oB.Handle, DBFBuffer^, ReadSize);
          BufCnt := RealRead div oB.Header.rec_size;
          for i := 0 to BufCnt - 1 do begin
            oB.IndRecBuf := DBFBuffer + oB.Header.rec_size * i;
            Inc(Rec);
            Key := EvaluteKeyExpr;
            AddKey(Key, Rec);
          end;
        until ( BufCnt <= 0 );
      end else Exception.Create('TNTXIndex: Record size too lage');
    finally
      Flush;
      FileSeek(NTXHandler, 0, 0);
      FileWrite(NTXHandler, FHead, SizeOf(NTX_HEADER));
      FNTXBuffers.Clear;
      FCreateIndexProc:= false;
      oB.IndState := false;
      oB.IndRecBuf := nil;
      MemMgr.oMem.FreeMem(DBFBuffer);
    end;
    if IsOpen then begin
      InternalFirst;
      KeyExpresion := FHead.key_expr;
      ForExpresion := FHead.for_expr;
      if ForExpresion <> '' then
        FForExists := true;
      Active := true;
    end;
  end else raise Exception.Create('TNTXIndex: Create index only on active DataSet');
end;

function TNTXIndex.SuiteFieldList(fl: String; out m: Integer): Integer;
begin
  if Temp then begin
    m := 0;
    Result := 0
  end else
    Result := FKeyParser.SuiteFieldList(fl, m);
end;

function TNTXIndex.SeekFields(const KeyFields: string;
  const KeyValues: Variant): Integer;
var
  m: Integer;
  Key, Key1: String;
  SeekOk: boolean;
begin
  Result := 0;
  FKeyParser.SuiteFieldList(KeyFields, m);
  if m > 0 then begin
    Key := FKeyParser.EvaluteKey(KeyFields, KeyValues);
    Key1 := FKeyParser.EvaluteKey;
    if Length(Key) = Length(Key1) then
      SeekOk := SeekFirstInternal(Key, false)
    else begin
      SeekFirstInternal(Key, true);
      SeekOk := FSeekOk;
    end;
    if SeekOk then Result := FSeekRecord;
  end;
end;

function TNTXIndex.GetOwnerTable: TDataSet;
begin
  Result := TDataSet(FIndexes.Owner);
end;

function TNTXIndex.SeekLastInternal(Key: String;
  SoftSeek: boolean): boolean;
var
  lResult, SoftSeekSet: boolean;

  procedure Pass(page_off: DWORD);
  var
    i: DWORD;
    page: pNTX_BUFFER;
    item: pNTX_ITEM;
    c: Integer;
  begin

    FNTXBuffers.GetPage(NTXHandler, page_off, page);

    if page.count > 0 then begin
      for i := 0 to page.count - 1 do begin

        item := pNTX_ITEM(pChar(page) + page.ref[i]);

        c := CmpKeys(item.key, pChar(Key), Length(Key));

        if c < 0 then begin //Key < item.key
          if ( item.page <> 0 ) then Pass(item.page);
          if (SoftSeek) and (not lResult) and ( not SoftSeekSet ) then begin
            FSeekRecord := item.rec_no;
            SoftSeekSet := true;
            SetString(FSeekKey, item.key, FHead.key_size);
            FSeekOk := true;
          end;
          Exit;
        end;

        if c = 0 then begin //Key = item.key
          FSeekRecord := item.rec_no;
          SetString(FSeekKey, item.key, FHead.key_size);
          FSeekOk := true;
          lResult := true;
        end;

      end;

    end;

    item := pNTX_ITEM(pChar(page) + page.ref[page.count]);
    if ( item.page <> 0 ) then Pass(item.page);

  end;

begin

  FSeekOk := false;

  SoftSeekSet := false;

  if FLock then
    try

      ClearIfChange;

      lResult := false;
      Pass(FHead.root);
      Result := lResult;

    finally
      FUnLock;
    end
  else
    Result := false;

end;

procedure TNTXIndex.SetRangeFields(FieldList: String;
  FieldValues: array of const);
var
  FieldVal: Variant;
  i: Integer;
begin
  FieldVal := VarArrayCreate([0, High(FieldValues)], varVariant);
  for i := 0 to High(FieldValues) do begin
    with FieldValues[I] do
      case VType of
        vtInteger:    FieldVal[i] := VInteger;
        vtBoolean:    FieldVal[i] := VBoolean;
        vtChar:       FieldVal[i] := VChar;
        vtExtended:   FieldVal[i] := VExtended^;
        vtString:     FieldVal[i] := VString^;
        //vtPChar:      FieldVal[i] := VPChar;
        //vtObject:     FieldVal[i] := VObject;
        //vtClass:      FieldVal[i] := VClass;
        vtAnsiString: FieldVal[i] := string(VAnsiString);
        vtCurrency:   FieldVal[i] := VCurrency^;
        vtVariant:    FieldVal[i] := VVariant^;
        //vtInt64:      FieldVal[i] := VInt64^;
    end;
  end;
  SetRangeFields(FieldList, FieldVal);
end;

procedure TNTXIndex.SetRangeFields(FieldList: String;
  FieldValues: Variant);
var
  Key: String;
begin
  Key := TrimRight(FKeyParser.EvaluteKey(FieldList, FieldValues));
  NTXRange.HiKey := Key;
  NTXRange.LoKey := Key;
  NTXRange.ReOpen;
end;

function TNTXIndex.GetIsRanged: boolean;
begin
  Result := NTXRange.Active;
end;

function TNTXIndex.InRange(Key: String): boolean;
begin
  Result := NTXRange.InRange(Key);
end;

procedure TNTXIndex.ClearIfChange;
var
  v: WORD;
begin
  if not FCreateIndexProc then begin
    v := FHead.version;
    FileSeek(NTXHandler, 0, 0);
    FileRead(NTXHandler, FHead, 12);
    if v <> FHead.version then FNTXBuffers.Clear;
  end;
end;

procedure TNTXIndex.StartUpdate(UnLock: boolean = true);
begin
  if FLock then
    try
      FLastOffset := FileSeek(NTXHandler, 0, 2);
      ClearIfChange;
    finally
      if UnLock then FUnLock;
    end;
end;

procedure TNTXIndex.Flush;
begin
  FNTXBuffers.Flush(NTXHandler);
  if not FCreateIndexProc then begin
    if FHead.version > 65530 then
      FHead.version := 0
    else
      FHead.version := FHead.version + 1;
    FileSeek(NTXHandler, 0, 0);
    FileWrite(NTXHandler, FHead, 12);
  end;
end;

procedure TNTXIndex.Reindex;
begin
  FReindex := true;
  try
    CreateIndex;
  finally
    FReindex := false;
  end;
end;

{ TNTXRange }

function TNTXRange.GetActive: boolean;
begin
  Result := FActive;
end;

function TNTXRange.InRange(S: String): boolean;
var
  l, c: Integer;
begin
  c := NTX.CompareKeys(pChar(HiKey), pChar(S), NTX.FHead.key_size);
  Result :=  (c <= 0); //HiKey <= S
  l := Length(LoKey);
  if l > 0 then begin
    c := NTX.CompareKeys(pChar(LoKey), pChar(S), l);
    Result := Result and (c <= 0); //LoKey < S
  end;
end;

procedure TNTXRange.ReOpen;
var
  oDB: TDBFNTX;
begin
  if not Active then begin
    Active := true;
  end else begin
    NTX.Active := true;
    oDB := TDBFNTX(NTX.OwnerTable);
    if oDB.Active then oDB.First;
  end;
end;

procedure TNTXRange.SetActive(const Value: boolean);
var
  oDB: TDBFNTX;
  l: boolean;
begin
  l := FActive;
  FActive := Value;
  oDB := TDBFNTX(NTX.OwnerTable);
  NTX.Active := true;
  if (l <> Value) and oDB.Active then begin
    oDB.First;
  end;
end;

{ TNTXBuffer }

constructor TNTXBuffer.Create;
begin
  inherited Create;
  Fchanged := false;
end;

{ TNTXBuffers }

function TNTXBuffers.FindIndex(page_offset: DWORD;
  out Ind: Integer): boolean;
var
  B: TNTXBuffer;
  beg, Mid: Integer;
begin
  Ind := Count;
  if ( Ind > 0 ) then begin
    beg := 0;
    B := TNTXBuffer(Items[beg]);
    if ( page_offset > B.Fpage_offset ) then begin
      repeat
        Mid := (Ind + beg) div 2;
        B := TNTXBuffer(Items[Mid]);
        if ( page_offset > B.Fpage_offset ) then
           beg := Mid
        else
           Ind := Mid;
      until ( ((Ind - beg) div 2) = 0 );
    end else
      Ind := beg;
    if Ind < Count then begin
      B := TNTXBuffer(Items[Ind]);
      Result := (page_offset = B.Fpage_offset);
    end else
      Result := false;
  end else
    Result := false;
end;

procedure TNTXBuffers.Flush(Handle: Integer);
var
  i: Integer;
begin
  for i := 0 to Count - 1 do begin
    with TNTXBuffer(Items[i]) do begin
      if Fchanged then begin
        FileSeek(Handle, Fpage_offset, 0);
        FileWrite(Handle, Fpage, SizeOf(NTX_BUFFER));
        Fchanged := false;
      end;
    end;
  end;
end;

function TNTXBuffers.GetPage(Handle: Integer; page_offset: DWORD;
  out page: pNTX_BUFFER; fRead: boolean = true): Integer;
var
  i: Integer;
  b: TNTXBuffer;
begin
  if FindIndex(page_offset, i) then begin
    b := TNTXBuffer(Items[i]);
    page := @b.Fpage;
    Result := i;
  end else begin
    Insert(i, TNTXBuffer.Create);
    Result := i;
    if fRead then begin
      FileSeek(Handle, page_offset, 0);
      with TNTXBuffer(Items[i]) do begin
        FileRead(Handle, Fpage, SizeOf(NTX_BUFFER));
        Fpage_offset := page_offset;
        page := @Fpage;
      end;
    end else
      with TNTXBuffer(Items[i]) do begin
        Fpage_offset := page_offset;
        page := @Fpage;
      end;
  end;
end;

function TNTXBuffers.GetNTXBuffer(Handle: Integer; page_offset: DWORD;
  out page: pNTX_BUFFER; fRead: boolean): Pointer;
var
  i: Integer;
begin
  if FindIndex(page_offset, i) then begin
    Result := Items[i];
    page := @TNTXBuffer(Result).Fpage;
  end else begin
    Insert(i, TNTXBuffer.Create);
    Result := Items[i];
    if fRead then begin
      FileSeek(Handle, page_offset, 0);
      with TNTXBuffer(Items[i]) do begin
        FileRead(Handle, Fpage, SizeOf(NTX_BUFFER));
        Fpage_offset := page_offset;
        page := @Fpage;
      end;
    end else
      with TNTXBuffer(Items[i]) do begin
        Fpage_offset := page_offset;
        page := @Fpage;
      end;
  end;
end;

procedure TNTXBuffers.SetChanged(i: Integer);
begin
  TNTXBuffer(Items[i]).Fchanged := true;
end;

procedure TNTXBuffers.SetPage(Handle: Integer; page_offset: DWORD; page: pNTX_BUFFER);
var
  i: Integer;
begin
  if FindIndex(page_offset, i) then
    with TNTXBuffer(Items[i]) do
      Fchanged := true;
end;

end.
