{Copyright:      Vlad Karpov  mailto:KarpovVV@protek.ru
 Author:         Vlad Karpov
 Remarks:        freeware, but this Copyright must be included

 Description:    To8Script - component for execute SQL scripts

 Version:        1.0.0

 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
}
unit o8Script;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, o8Stmt, o8Env, o8Session, o8StmtOrd, OCI;

type

  To8Script = class(TComponent)
  private
    FSession: To8Session;
    FSQL: TStrings;
    function GetSession: To8Session;
    procedure SetSession(const Value: To8Session);
    function GetSQLScript: TStrings;
    procedure SetSQLScript(const Value: TStrings);
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ExecSQLScript;
  published
    property oraSession: To8Session read GetSession write SetSession;
    property SQLScript: TStrings read GetSQLScript write SetSQLScript;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('VK NLO', [To8Script]);
end;

{ To8Script }

constructor To8Script.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSQL := TStringList.Create;
end;

destructor To8Script.Destroy;
begin
  oraSession := nil;
  FSQL.Destroy;
  inherited Destroy;
end;

procedure To8Script.ExecSQLScript;
var
  i: Integer;
  CurS: String;
  CurSQL: TStringList;
  FStmt: To8StmtOrd;
begin
  FStmt:= To8StmtOrd.Create(self);
  FStmt.oraSession := FSession;
  CurSQL := TStringList.Create;
  CurSQL.Clear;
  if FStmt.oraSession <> nil then
    if FStmt.oraSession.Active then
    begin
      i := 0;
      while i < FSQL.Count do
      begin
        CurS := FSQL.Strings[i];
        if CurS = '/' then  //#13#10
        begin
          FStmt.SQL := CurSQL;
          CurSQL.Clear;
          try
            FStmt.ExecSql;
          except
            ShowMessage(FStmt.SQL.Text + #13#10 + ':' + #13#10 + FStmt.GetLastErrMessage);
          end;
        end else
          CurSQL.Add(CurS);
        Inc(i);
      end;
      if CurSQL.Count > 0 then
      begin
        FStmt.SQL := CurSQL;
        try
          FStmt.ExecSql;
        except
          ShowMessage(FStmt.SQL.Text + #13#10 + ':' + #13#10 + FStmt.GetLastErrMessage);
        end;
      end;
    end;
  CurSQL.Destroy;
  FStmt.Destroy;
end;

function To8Script.GetSession: To8Session;
begin
  Result := FSession;
end;

function To8Script.GetSQLScript: TStrings;
begin
  Result := FSQL;
end;

procedure To8Script.SetSession(const Value: To8Session);
begin
  if oraSession <> nil then oraSession.RemoveStatment(self);
  FSession := Value;
  if oraSession <> nil then oraSession.AddStatment(self);
end;

procedure To8Script.SetSQLScript(const Value: TStrings);
begin
   FSQL.Clear;
   FSQL.Assign(Value);
end;

end.
